-- Code from section 1.4

module RoundRobin where

data Colour = Blue | Red
data Ord a => Tree a = Null | Fork Colour a (Tree a) (Tree a)

isEmpty :: Ord a => Tree a -> Bool
isEmpty Null = True
isEmpty (Fork col x a b) = False

minElem :: Ord a => Tree a -> a
minElem (Fork col x a b) = x

deleteMin :: Ord a => Tree a -> Tree a
deleteMin (Fork col x a b) = merge a b

insert :: Ord a => a -> Tree a -> Tree a
insert x a = merge (Fork Blue x Null Null) a

merge :: Ord a => Tree a -> Tree a -> Tree a
merge a Null = a
merge Null b = b
merge a b
   | minElem a <= minElem b = join a b
   | otherwise = join b a

join (Fork Blue x a b) c = Fork Red x (merge a c) b
join (Fork Red x a b) c = Fork Blue x a (merge b c)
