> module Stream where

> import Comonad

> data Stream a = Cons a (Stream a)

> shd :: Stream a -> a
> shd (Cons x xs) = x

> stl :: Stream a -> Stream a
> stl (Cons x xs) = xs

> instance Functor Stream where
>	fmap f xs = Cons (f (shd xs)) (fmap f (stl xs))

> instance Comonad Stream where
>	eval = shd
>	xs =>> f = Cons (f xs) (stl xs =>> f)

> zipStream :: (Stream a, Stream b) -> Stream (a, b)
> zipStream (xs, ys) = zipper xs ys
>	where	zipper xs ys = Cons (shd xs, shd ys) (zipper (stl xs) (stl ys))

> unzipStream :: Stream (a, b) -> (Stream a, Stream b)
> unzipStream xys = (fmap fst xys, fmap snd xys)

> listToStream :: [a] -> Stream a
> listToStream = foldr Cons undefined

> streamToList :: Stream a -> [a]
> streamToList xs = shd xs : streamToList (stl xs)
