/*
 * Defnitions shared by all Pan-generated plugins.
 *
 *
 */

#ifndef __PanPlugin_H__
#define __PanPlugin_H__

#include "PITypes.h"
#include "PIFilter.h"			// Filter Photoshop header file.
#include "PIUtilities.h"		// SDK Utility library.

//-------------------------------------------------------------------------------
//	Definitions -- Constants
//-------------------------------------------------------------------------------

#define useAlpha 			0		// use alpha

#define kPercentMin			1
#define kPercentMax			99

#define kGutter				2		// 2 pixel gutter

//-------------------------------------------------------------------------------
//	Globals -- structures
//-------------------------------------------------------------------------------

// Windows handle for our plug-in (seen as a dynamically linked library):
//extern HANDLE hDllInstance;

typedef struct TParameters {
 // This is our parameter structure that has an entry in the parameter block.


} TParameters, *PParameters, **HParameters;

typedef struct Globals
{ // This is our structure that we use to pass globals between routines:

	short		*result;			// Must always be first in Globals.
	FilterRecord	*filterParamBlock;		// Must always be second in Globals.

	Rect	        proxyRect;
        Boolean         useAdvance;
  //        short           percent;
  //        Boolean         queryForParameters;
        short           rowSkip;

} Globals, *GPtr, **GHdl;

//-------------------------------------------------------------------------------
//	Globals -- definitions and macros
//-------------------------------------------------------------------------------

#define gResult 		(*(globals->result))
#define gStuff  		(globals->filterParamBlock)
#define gProxyRect		(globals->proxyRect)

#define gParams 		(*gStuff->parameters)
#define gUseAdvance		(globals->useAdvance)
#define gRowSkip		(globals->rowSkip)

//-------------------------------------------------------------------------------
//	Prototypes
//-------------------------------------------------------------------------------

OSErr ReadScriptParams (GPtr globals);	 // Read any scripting params.
OSErr WriteScriptParams (GPtr globals);	 // Write any scripting params.

void SetupFilterRecordForProxy (GPtr globals);	 

void DispatchFilterRect (GPtr globals, const Boolean useProgress);

//-------------------------------------------------------------------------------

#endif // __PanPlugin_H__
